#define MAX_X 319
#define MAX_Y 199
#define MIN_X 1
#define MIN_Y 1
#define antobj 3

unsigned char envmap[256][256];
short *buffer;
short *scr;
short *bumpy;
short *bumpx;

#include <vesa20.h>
#include "camera.h"
#include "tricks.h"
#include "gfx.h"

byte  *bumpmap;
byte  *bumpback;
byte  *bumppics[3];
byte  *flaremap;

fstream fout("data\\bumpface.spl");

// ******************************************************************

struct pos {
	float xp[200];
	float yp[200];
	float zp[200];
	float xv[200];
	float yv[200];
	float zv[200];
};

cam *C;

obj *objList;

byte pal[256*3];
int  *df,cnt,ant;

short transtableR[65536][32];
short transtableG[65536][32];
short transtableB[65536][32];

pos keyframe;

// ******************************************************************

void doBumpR(int lightx, int lighty);
void doBumpB(int lightx, int lighty);
void doBumpG(int lightx, int lighty);

void doBumpBR(int lxB,int lyB, int lxR,int lyR);

void doBumpRGB(int lxR,int lyR,int lxG,int lyG,int lxB,int lyB);

void bump(int lightx,int lighty);
void flare(obj *O);
void mapflare(int xs, int ys,short table[65536][32]);
void bumpme(int lightx, int lighty);

void init();
float setMap();
void deinit();
int checkkey();

void rotObj(obj *O,float x,float y,float z);
void posCam(obj *O,const cam *C,float p);
void drawObj(int*list,int num,byte *dest);

void drawPoly(int,byte *dest);
void prepObj();
int  comp(const void *a,const void *b);

int readframe();
float spline(float,float*);
void newpic();
float setmap();

// ******************************************************************
// ******************************************************************
// ******************************************************************
// ******************************************************************

void main(int argc, char *argv[])
{

  init();
  

  if(argc>1){
    while(checkkey()){
      scr = (short*)scrptr;
      fastMemClear((byte*)scr,32000);

      rotObj(&objList[0],0.00,0.00,-0.05);
      rotObj(&objList[1],0.00,0.00,0.15);
      rotObj(&objList[2],0.00,0.00,0.1);

      O=&objList[1];
      posCam(O,C,600);
      doBumpRGB(O->v[0].x*240,-O->v[0].z*240,
                O->v[1].x*240,-O->v[1].z*240,
                O->v[2].x*240,-O->v[2].z*240);

      O=&objList[0];
      posCam(O,C,600);
      prepObj();

      O=&objList[2];
      posCam(O,C,600);
      mapflare(O->rv[0].px-32,O->rv[0].py-32,transtableR);
      mapflare(O->rv[1].px-32,O->rv[1].py-32,transtableB);
      pageFlip320x200();
    }
    fout << ant;
  }else{
    float t=1;
    readframe();
    newpic();

    while(!kbhit()&&t<ant-3){
      C->x=spline(t,keyframe.xp);
      C->y=spline(t,keyframe.yp);
      C->z=spline(t,keyframe.zp);
      C->xv=spline(t,keyframe.xv);
      C->yv=spline(t,keyframe.yv);
      C->zv=spline(t,keyframe.zv);

      t+=0.04;     

      if(t>=12&&t<12.04) newpic();
      if(t>=24&&t<24.04) newpic();

      scr = (short*)scrptr;
      fastMemClear((byte*)scr,32000);

      rotObj(&objList[0],0.00,0.00,-0.05);
      rotObj(&objList[1],0.00,0.00,0.15);
      rotObj(&objList[2],0.00,0.00,0.1);

      O=&objList[1];
      posCam(O,C,600);
    
      doBumpRGB(O->v[0].x*240,-O->v[0].z*240,
                O->v[1].x*240,-O->v[1].z*240,
                O->v[2].x*240,-O->v[2].z*240);

      O=&objList[0];
      posCam(O,C,600);
      prepObj();

      O=&objList[2];
      posCam(O,C,600);
      mapflare(O->rv[0].px-32,O->rv[0].py-32,transtableG);
      mapflare(O->rv[1].px-32,O->rv[1].py-32,transtableR);
      mapflare(O->rv[2].px-32,O->rv[2].py-32,transtableB);
      pageFlip320x200();
    }
  }

  deinit();
}

void newpic()
{
  static int picnum=0;
  fastMemCopy(bumpback,bumpmap,16384);

  byte*src = (byte*)bumppics[picnum];
  byte*dst = bumpmap;

  for(int y=0;y<256;y++){
    for(int x=0;x<256;x++){
      int tmp=*dst+*src++;
      if(tmp>255)tmp=255;
      *dst++=tmp;
    }
  }

  src = bumpmap;

  for(int i=0;i<65280;i++,src++){
     bumpx[i]=(src[-1]-src[1])>>1;
     bumpy[i]=(src[-256]-src[256])>>1;
  }   

  picnum++;
  if(picnum==3)picnum=0;
}


void mapflare(int xs, int ys,short table[65536][32])
{
  int yd=64;
  int y=0;
  int xd=64;
  int x=0;

  if(ys<0)
    y=-ys;
  else if(ys>136)
    yd=200-ys;

  if(xs<0)
    x=-xs;
  else if(xs>286)
    xd=320-xs;

  for(;y<yd;y++){
    short *tmp=scr+(y+ys)*320+xs;

    for(int x=0;x<xd;x++){
      *tmp=table[*tmp&0xffff][flaremap[(y<<6)+x]>>3];
      tmp++;
    }
  }
}

void deinit()
{
  SetText();

  delete[] O->f;
  delete[] O->rv;
  delete[] O->v;
  delete C;
  delete[] buffer;
  delete[] bumpmap;
  delete[] bumpback;
  delete[] bumpy;
  delete[] bumpx;
  delete[] flaremap;

  for(int i=0;i<3;i++){
    delete[] bumppics[i];
  }
}

int readframe() {
		char tmp;
    fout >> ant;
		for(int a=0;a<ant;a++){
      fout >> keyframe.xp[a] >> tmp >> keyframe.yp[a] >> tmp >> keyframe.zp[a];
      fout >> keyframe.xv[a] >> tmp >> keyframe.yv[a] >> tmp >> keyframe.zv[a];
      if(fout.fail()){
         setText();
         cout << "error reading spline "<< endl;
         cout << "ant " << ant << " a: " << a << endl;
         exit(0);
      }
		}

	return ant;
}

void init()
{
  cnt=0;
  O=new obj;
  C=new cam;

  C->x=0;
  C->y=-2;
  C->z=-2.5;
  C->xv=0.1;
  C->yv=0.65;
  C->zv=0;

  objList=new obj[antobj];

  readobj( &objList[0], "data\\bumpface.x");
  readobj( &objList[1], "data\\fakeobj.x");
  readobj( &objList[2], "data\\fakeobj.x");

  setMap();
  rotObj(&objList[2],3.14,0,0);

  df=new int[objList[0].faces];

  O=objList;

  for(int i=0;i<antobj;i++){
    objList[i].x=0;
    objList[i].y=0;
    objList[i].z=0;
  }

   buffer = new short[65536];
   bumpmap = new byte[65536];
   bumpback = new byte[65536];
   bumpy = new short[65536];
   bumpx = new short[65536];

   load("data\\bumpmap.raw", bumpback, 65536 );

   for( i=0;i<256;i++)
      for(int j=0;j<256;j++) {
         unsigned int col=256-sqrt( ((i<<1)-256)*((i<<1)-256)
                                  + ((j<<1)-256)*((j<<1)-256) );
         if(col<256)
            envmap[i][j]=(byte)col;
      }

   envmap[128][128] = 255;  
   byte* src = bumpmap+256;

   for(i=0;i<65280;i++,src++){
       bumpx[i]=(src[-1]-src[1])>>1;
       bumpy[i]=(src[-256]-src[256])>>1;
   }   

   for(i=0;i<3;i++){
     bumppics[i] = new byte[65536];
   }

   load("data\\bump1.raw",bumppics[0],65536);
   load("data\\bump2.raw",bumppics[1],65536);
   load("data\\bump3.raw",bumppics[2],65536);

   flaremap = new byte[4096];
   load("data\\flare.raw", flaremap, 4096);

   for(i=0;i<65536;i++){
     for(int j=0;j<32;j++){
        int r=(i>>11)&0x1f;
        int g=(i>>5)&0x3f;
        int b=i&0x1f;
  
        r+=j;
        if(r>31) r=31;

        transtableR[i][j]=(r<<11)+(g<<5)+b;
     }
   }     

   for(i=0;i<65536;i++){
     for(int j=0;j<32;j++){
        int r=(i>>11)&0x1f;
        int g=(i>>5)&0x3f;
        int b=i&0x1f;
  
        g+=j<<1;
        if(g>63) g=63;

        transtableG[i][j]=(r<<11)+(g<<5)+b;
     }
   }     

   for(i=0;i<65536;i++){
     for(int j=0;j<32;j++){
        int r=(i>>11)&0x1f;
        int g=(i>>5)&0x3f;
        int b=i&0x1f;
  
        b+=j;
        if(b>31) b=31;

        transtableB[i][j]=(r<<11)+(g<<5)+b;
     }
   }     



   set320x200x16();
}

void doBumpRGB(int lxR,int lyR,int lxG,int lyG,int lxB,int lyB)
{
  short *srcx=bumpx+257;
  short *srcy=bumpy+257;
  short *dst =buffer+257;

  int xdR,ydR,
      xdG,ydG,
      xdB,ydB;
  int i=254;

  do{
    int j=254;

    do{
      xdR=*srcx+lxR;
      xdG=*srcx+lxG;
      xdB=*srcx+lxB;

      ydR=*srcy+lyR;
      ydG=*srcy+lyG;
      ydB=*srcy+lyB;

      srcx++;
      srcy++;
      lxR++;
      lxG++;
      lxB++;

      short tmp=0;
      
      if(!(xdR&0xFF00)&&!(ydR&0xFF00))
         tmp=(envmap[ydR][xdR]>>3)<<11; // (color>>3)<<11 ...

      if(!(xdG&0xFF00)&&!(ydG&0xFF00))
         tmp+=(envmap[ydG][xdG]>>2)<<5;

      if(!(xdB&0xFF00)&&!(ydB&0xFF00))
         *dst=tmp+(envmap[ydB][xdB]>>3);
      else
         *dst=tmp;

      dst++;
    }while(--j);

    lyR++;
    lyG++;
    lyB++;
    lxR-=254;
    lxG-=254;
    lxB-=254;
    dst+=2;
    srcx+=2;
    srcy+=2;
  }while(--i);
}


void doBumpBR(int lxB,int lyB,int lxR, int lyR)
{
  short *srcx=bumpx+257;
  short *srcy=bumpy+257;
  short *dst =buffer+257;

  int xdB,ydB,xdR,ydR;
  int i=254;

  do{
    int j=254;

    do{
      xdB=*srcx+lxB;
      xdR=*srcx+lxR;
      ydB=*srcy+lyB;
      ydR=*srcy+lyR;

      srcx++;
      srcy++;
      lxB++;
      lxR++;

      short tmp=0;
      
      if(!(xdB&0xFF00)&&!(ydB&0xFF00))
         tmp=envmap[ydB][xdB]>>3;

      if((xdR&0xFF00)||(ydR&0xFF00))
         *dst=tmp;
      else
         *dst=tmp+((envmap[ydR][xdR]>>3)<<11); // (color>>3)<<11 ...

      dst++;
    }while(--j);

    lyB++;
    lyR++;
    lxB-=254;
    lxR-=254;
    dst+=2;
    srcx+=2;
    srcy+=2;
  }while(--i);
}

void doBumpB(int lightx, int lighty )
{
  short *srcx=bumpx+257;
  short *srcy=bumpy+257;
  short *dst =buffer+257;

  int ly=lighty;
  int lx=lightx;
  int xd,yd;
  int i=254;

  do{
    int j=254;
    do{
      xd=*srcx+lx;
      yd=*srcy+ly;

      srcx++;
      srcy++;
      lx++;

      if((xd&0xFF00)||(yd&0xFF00))
         *dst=0;
      else
         *dst=envmap[yd][xd]>>3;
      dst++;
    }while(--j);

    ly++;
    lx-=254;
    dst+=2;
    srcx+=2;
    srcy+=2;
  }while(--i);
}

void doBumpG(int lightx, int lighty )
{
  short *srcx=bumpx+257;
  short *srcy=bumpy+257;
  short *dst =buffer+257;

  int ly=lighty;
  int lx=lightx;
  int xd,yd;
  int i=254;

  do{
    int j=254;
    do{
      xd=*srcx+lx;
      yd=*srcy+ly;

      srcx++;
      srcy++;
      lx++;

      if(!(xd&0xFF00)&& !(yd&0xFF00))
         *dst+=(envmap[yd][xd]>>2)<<5;
      dst++;
    }while(--j);

    ly++;
    lx-=254;
    dst+=2;
    srcx+=2;
    srcy+=2;
  }while(--i);
}

void doBumpR(int lightx, int lighty )
{
  short *srcx=bumpx+257;
  short *srcy=bumpy+257;
  short *dst =buffer+257;

  int ly=lighty;
  int lx=lightx;
  int xd,yd;
  int i=254;

  do{
    int j=254;
    do{
      xd=*srcx+lx;
      yd=*srcy+ly;

      srcx++;
      srcy++;
      lx++;

      if(!(xd&0xFF00)&& !(yd&0xFF00))
         *dst+=(envmap[yd][xd]>>3)<<11;
      dst++;
    }while(--j);

    ly++;
    lx-=254;
    dst+=2;
    srcx+=2;
    srcy+=2;
  }while(--i);
}




float setMap() {
  float max_x;
  float max_y;
  float min_x;
  float min_y;
  float qx;
  float qy;

  for(int q=0;q<antobj;q++) {
    max_x=-99999;
    max_y=-99999;
    min_x=99990;
    min_y=99990;

    for(int w=0;w<objList[q].vertices;w++) {
      if(objList[q].v[w].x>max_x) max_x=objList[q].v[w].x;
      if(objList[q].v[w].x<min_x) min_x=objList[q].v[w].x;
      if(objList[q].v[w].z>max_y) max_y=objList[q].v[w].z;
      if(objList[q].v[w].z<min_y) min_y=objList[q].v[w].z;
    }
    qx=240.0/(max_x-min_x);
    qy=240.0/(max_y-min_y);

    for(int a=0;a<objList[q].vertices;a++) {
      objList[q].rv[a].u=(objList[q].v[a].x-min_x)*qx+5;    
      objList[q].rv[a].v=(objList[q].v[a].z-min_y)*qy+5;    
    }
  }

  return qx;
}

void prepObj()
{
  int count=0;
  for(int i=0;i<O->faces;i++) {
//    if(O->f[i].zn>0)
      df[count++] = i;
  }
  qsort(df,count,sizeof(int),comp);
  drawObj(df,count,buf);
}

int checkkey()
{
  char key=0;
  if(kbhit()){
    key = getch();

    switch( key ){
      case 27: return 0;
      case 'e': C->y-=0.5; break;
      case 'c': C->y+=0.5; break;
      case 'a': C->x-=0.5; break;
      case 'd': C->x+=0.5; break;
      case 's': C->z-=0.5; break;
      case 'w': C->z+=0.5; break;

      case 't': C->xv+=0.05; break;
      case 'b': C->xv-=0.05; break;
      case 'y': C->yv+=0.05; break;
      case 'h': C->yv-=0.05; break;
      case 'j': C->zv+=0.05; break;
      case 'g': C->zv-=0.05; break;
      case 32 : fout<<C->x<<","<<C->y<<","<<C->z<<endl;
                fout<<C->xv<<","<<C->yv<<","<<C->zv<<endl;
                cnt++; break;
      case 'n': newpic(); break;
    }
  }

  return 1;
}



void rotObj(obj *O, float x, float y, float z)
{
   // precalc values..

   float sx = sin(x);
   float sy = sin(y);
   float sz = sin(z);

   float cx = cos(x);
   float cy = cos(y);
   float cz = cos(z);

   float mx1 = sx*sy*sz + cz*cx;
   float my1 = sx*cy;
   float mz1 = sz*cx - sx*sy*cz;

   float mx2 = cx*sy*sz - cz*sx;
   float my2 = cx*cy;
   float mz2 = -cz*sy*cx - sz*sx;

   float mx3 = -sz*cy;
   float my3 = sy;
   float mz3 = cz*cy;

   for( int i=0; i<O->vertices; i++ )
   {
      // rotate coords

      x = O->v[i].x;
      y = O->v[i].y;
      z = O->v[i].z;

      O->v[i].x = x*mx1 + y*my1 + z*mz1;
      O->v[i].y = x*mx2 + y*my2 + z*mz2;
      O->v[i].z = x*mx3 + y*my3 + z*mz3;

      // rotate normals

      x = O->v[i].xn;
      y = O->v[i].yn;
      z = O->v[i].zn;

      O->v[i].xn = x*mx1 + y*my1 + z*mz1;
      O->v[i].yn = x*mx2 + y*my2 + z*mz2;
      O->v[i].zn = x*mx3 + y*my3 + z*mz3;
   }
}

void posCam(obj *O,const cam *C,float p)
{
   float sx = sin(C->xv);
   float sy = sin(C->yv);
   float sz = sin(C->zv);

   float cx = cos(C->xv);
   float cy = cos(C->yv);
   float cz = cos(C->zv);

   float mx1 = sx*sy*sz + cz*cx;
   float my1 = sx*cy;
   float mz1 = sz*cx - sx*sy*cz;

   float mx2 = cx*sy*sz - cz*sx;
   float my2 = cx*cy;
   float mz2 = -cz*sy*cx - sz*sx;

   float mx3 = -sz*cy;
   float my3 = sy;
   float mz3 = cz*cy;

   for(int i=0;i<O->vertices;i++){
      float x = O->v[i].x - C->x + O->x;
      float y = O->v[i].y - C->y + O->y;
      float z = O->v[i].z - C->z + O->z;

      O->rv[i].x = x*mx1 + y*my1 + z*mz1;
      O->rv[i].y = x*mx2 + y*my2 + z*mz2;
      O->rv[i].z = x*mx3 + y*my3 + z*mz3;

      x=O->rv[i].x;
      y=O->rv[i].y;
      z=O->rv[i].z;

      // project

        float zi = 1/z;
        O->rv[i].px = (x*zi)*p + 160;
        O->rv[i].py = (y*zi)*p*.8 + 100;

        x = O->v[i].xn;
        y = O->v[i].yn;
        z = O->v[i].zn;

        O->rv[i].xn = x*mx1 + y*my1 + z*mz1;
        O->rv[i].yn = x*mx2 + y*my2 + z*mz2;
        O->rv[i].zn = x*mx3 + y*my3 + z*mz3;
   }

   for(i=0;i<O->faces;i++){
     float p1x = O->rv[O->f[i].p1].x;
     float p1y = O->rv[O->f[i].p1].y;
     float p1z = O->rv[O->f[i].p1].z;

     float p2x = O->rv[O->f[i].p2].x;
     float p2y = O->rv[O->f[i].p2].y;
     float p2z = O->rv[O->f[i].p2].z;

     float p3x = O->rv[O->f[i].p3].x;
     float p3y = O->rv[O->f[i].p3].y;
     float p3z = O->rv[O->f[i].p3].z;
/*
      O->f[i].xn = ((p3y - p2y) * (p1z - p2z))
                 - ((p1y - p2y) * (p3z - p2z));
      O->f[i].yn = ((p3z - p2z) * (p1x - p2x))
                 - ((p1z - p2z) * (p3x - p2x));
*/
      O->f[i].zn = ((p3y - p2y) * (p1x - p2x))
                 - ((p1y - p2y) * (p3x - p2x));
      O->f[i].z  = (p1z+p2z+p3z)*0.333333333333333333333333;
   }
}




int comp(const void *a,const void *b)
{
   float za = O->f[*(int*)a].z;
   float zb = O->f[*(int*)b].z;

   if(za>zb)       
      return -1;     
   else if(za<zb)
      return 1;
   else
      return 0;
}

void drawObj(int *faces,int num,byte *dest){  
	drawpoly dp;
	drawpoly clipped;
  dp.pcount=3;
  int q;
  int *p=new int[3];

  for(int i=0;i<num;i++) {
    p[0]=O->f[faces[i]].p1;
    p[1]=O->f[faces[i]].p2;
    p[2]=O->f[faces[i]].p3;

    for(int q=0;q<3;q++) {
      dp.points[q].x=O->rv[p[q]].px;
      dp.points[q].y=O->rv[p[q]].py;
      dp.points[q].z=O->rv[p[q]].z;     

        dp.points[q].u=O->rv[p[q]].u;
        dp.points[q].v=O->rv[p[q]].v;
    }

    switch(clipchk(dp.points)){
      case 0:
        mapPoly(&dp);
				break;
			case 1:
			case 2:
      case 3:
				clip(&dp,&clipped);
				mapPoly(&clipped);
				break;
			default: break;
    }

  }
}
